package com.ruoyi.bst.snapshot.service;

import java.util.List;

import com.ruoyi.bst.snapshot.domain.Snapshot;
import com.ruoyi.bst.snapshot.domain.SnapshotQuery;
import com.ruoyi.bst.snapshot.domain.SnapshotVO;
import com.ruoyi.bst.snapshot.domain.enums.SnapshotType;
import com.ruoyi.bst.snapshot.domain.vo.SnapshotDateVO;

/**
 * 快照Service接口
 *
 * @author ruoyi
 * @date 2025-05-08
 */
public interface SnapshotService
{
    /**
     * 查询快照
     *
     * @param id 快照主键
     * @return 快照
     */
    public SnapshotVO selectSnapshotById(Long id);

    /**
     * 查询快照列表
     *
     * @param snapshot 快照
     * @return 快照集合
     */
    public List<SnapshotVO> selectSnapshotList(SnapshotQuery snapshot);

    /**
     * 新增快照
     *
     * @param snapshot 快照
     * @return 结果
     */
    public int insertSnapshot(Snapshot snapshot);

    /**
     * 修改快照
     *
     * @param snapshot 快照
     * @return 结果
     */
    public int updateSnapshot(Snapshot snapshot);

    /**
     * 批量删除快照
     *
     * @param ids 需要删除的快照主键集合
     * @return 结果
     */
    public int deleteSnapshotByIds(Long[] ids);

    /**
     * 删除快照信息
     *
     * @param id 快照主键
     * @return 结果
     */
    public int deleteSnapshotById(Long id);

    /**
     * 记录值
     * @param type
     * @param value
     * @return
     */
    public int record(SnapshotType type, String value);

    /**
     * 查询日期快照
     * @param query
     * @return
     */
    public List<SnapshotDateVO> selectSimpleForDate(SnapshotQuery query);
}
